﻿using System.Collections.Generic;
using System.Windows.Controls;
using System.Linq;
using Telerik.Windows.Data;
using Telerik.Windows.Controls;

namespace CustomFilterRow_SL
{
	public partial class TextColumnHeader 
	{
		private RadGridView radGridView;
		//private CustomFilterDescriptor customFilterDescriptor;


		public TextColumnHeader()
		{
			InitializeComponent();
		}

		protected override void OnFilterDescriptorChanged(FilterDescriptor oldValue, FilterDescriptor newValue)
		{
			base.OnFilterDescriptorChanged(oldValue, newValue);

			if (newValue != null)
			{
				newValue.Value = string.Empty;
			}
		}

		protected override IEnumerable<FilterOperator> ApplicableFilterOperators
		{
			get
			{
				return new FilterOperator[]
				{
					FilterOperator.StartsWith,
					FilterOperator.EndsWith,
					FilterOperator.Contains,
					FilterOperator.DoesNotContain,
					FilterOperator.IsContainedIn
				};
			}
		}

		string oldValue = "";
		string newValue = "";
		CustomFilterDescriptor desc;

		private void TextBox_TextChanged(object sender, TextChangedEventArgs e)
		{			
			var textBox = sender as TextBox;
			newValue = textBoxFilterValue.Text;

			this.radGridView = textBox.ParentOfType<RadGridView>();
			var context = textBox.DataContext as TextColumnHeader;						

			if (desc == null)
			{
				desc = new CustomFilterDescriptor(this.radGridView.Columns.OfType<GridViewDataColumn>()) { FilterValue = textBox.Text };
				
			}

			this.radGridView.FilterDescriptors.Remove(desc);
			this.desc.FilterValue = this.textBoxFilterValue.Text;
			this.radGridView.FilterDescriptors.Add(desc);
		}
	}
}
